# themeparks
api.themeparks.wiki

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0-alpha
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import openapi_client
from pprint import pprint
from openapi_client.api import destinations_api
from openapi_client.model.destinations_response import DestinationsResponse
# Defining the host is optional and defaults to https://api.themeparks.wiki/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "https://api.themeparks.wiki/v1"
)



# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = destinations_api.DestinationsApi(api_client)
    
    try:
        # Get a list of supported destinations available on the live API
        api_response = api_instance.get_destinations()
        pprint(api_response)
    except openapi_client.ApiException as e:
        print("Exception when calling DestinationsApi->get_destinations: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.themeparks.wiki/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DestinationsApi* | [**get_destinations**](docs/DestinationsApi.md#get_destinations) | **GET** /destinations | Get a list of supported destinations available on the live API
*EntitiesApi* | [**get_entity**](docs/EntitiesApi.md#get_entity) | **GET** /entity/{entityID} | Get entity document
*EntitiesApi* | [**get_entity_children**](docs/EntitiesApi.md#get_entity_children) | **GET** /entity/{entityID}/children | Get all children for a given entity document
*EntitiesApi* | [**get_entity_live_data**](docs/EntitiesApi.md#get_entity_live_data) | **GET** /entity/{entityID}/live | Get live data for this entity and any child entities
*EntitiesApi* | [**get_entity_schedule_upcoming**](docs/EntitiesApi.md#get_entity_schedule_upcoming) | **GET** /entity/{entityID}/schedule | Get entity schedule
*EntitiesApi* | [**get_entity_schedule_year_month**](docs/EntitiesApi.md#get_entity_schedule_year_month) | **GET** /entity/{entityID}/schedule/{year}/{month} | Get entity schedule for a specific month and year


## Documentation For Models

 - [BoardingGroupState](docs/BoardingGroupState.md)
 - [DestinationEntry](docs/DestinationEntry.md)
 - [DestinationParkEntry](docs/DestinationParkEntry.md)
 - [DestinationsResponse](docs/DestinationsResponse.md)
 - [EntityChild](docs/EntityChild.md)
 - [EntityChildrenResponse](docs/EntityChildrenResponse.md)
 - [EntityData](docs/EntityData.md)
 - [EntityDataLocation](docs/EntityDataLocation.md)
 - [EntityLiveData](docs/EntityLiveData.md)
 - [EntityLiveDataResponse](docs/EntityLiveDataResponse.md)
 - [EntityScheduleResponse](docs/EntityScheduleResponse.md)
 - [EntityType](docs/EntityType.md)
 - [LiveQueue](docs/LiveQueue.md)
 - [LiveQueueBOARDINGGROUP](docs/LiveQueueBOARDINGGROUP.md)
 - [LiveQueuePAIDRETURNTIME](docs/LiveQueuePAIDRETURNTIME.md)
 - [LiveQueueRETURNTIME](docs/LiveQueueRETURNTIME.md)
 - [LiveQueueSTANDBY](docs/LiveQueueSTANDBY.md)
 - [LiveShowTime](docs/LiveShowTime.md)
 - [LiveStatusType](docs/LiveStatusType.md)
 - [PriceData](docs/PriceData.md)
 - [ReturnTimeState](docs/ReturnTimeState.md)
 - [ScheduleEntry](docs/ScheduleEntry.md)
 - [TagData](docs/TagData.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author




## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in openapi_client.apis and openapi_client.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from openapi_client.api.default_api import DefaultApi`
- `from openapi_client.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import openapi_client
from openapi_client.apis import *
from openapi_client.models import *
```

